<template>
  <autocomplete
    ref="autocomplete"
    class="i-autocomplete"
    :search="search"
    :placeholder="placeholder"
    :get-result-value="getResultValue"
    :default-value="defaultValue"
    @submit="onSelect">
    <template #result="{ result, props }">
      <li v-bind="props" v-html="result.descriptionHtml" />
    </template>
  </autocomplete>
</template>

<script>
  import Autocomplete from '@trevoreyre/autocomplete-vue';

  export default {
    components: {
      Autocomplete,
    },

    props: {
      placeholder: String,
      value: Object,
    },

    data() {
      return {
        timeout: null,
        previousInput: this.value ? this.value.description : null,
        previousResults: [],
      };
    },

    computed: {
      defaultValue() {
        return this.value ? this.value.description : null;
      },
    },

    methods: {
      getResultValue(result) {
        return result.description.split(/,/)[0].trim();
      },

      search(input) {
        if (input === this.previousInput) {
          return this.previousResults;
        }

        this.$emit('input', null);

        if (!input) {
          this.previousInput = null;
          this.previousResults = [];
          return [];
        }

        this.timeout && clearTimeout(this.timeout);

        return new Promise((resolve) => {
          this.timeout = setTimeout(async () => {
            try {
              let response = await this.$axios.get(`places/autocomplete`, {
                params: { input, locale: this.$i18n.locale },
              });

              this.previousInput = input;
              this.previousResults = response.data.data;
              return resolve(response.data.data);
            } catch (error) {
              console.error(error);
            }
          }, 250);
        });
      },

      onSelect(result) {
        this.previousInput = this.getResultValue(result);
        this.previousResults = [];
        this.$refs.autocomplete.$refs.input.blur();

        this.$emit('input', {
          key: result.placeId,
          description: this.previousInput,
        });
      },
    },
  };
</script>

<style lang="scss" src="~/assets/styles/autocomplete.scss"></style>

<style lang="scss">
  .i-autocomplete {
    width: 100%;
    height: rs(58px);
  }

  .i-autocomplete .autocomplete[data-loading='true']::after {
    right: rs(7px);
  }

  .i-autocomplete .autocomplete-input {
    width: 100%;
    height: rs(58px);
    border: 0;
    border-radius: rs(math.div(58px, 2));
    background-color: #f5f5f5;
    padding: rs(19px) rs(24px) rs(18px);
    font-size: rf(18px);
    font-weight: bold;
    color: rgba(#575167, 0.8);

    @include placeholder {
      color: rgba(#575167, 0.4);
    }

    &:focus {
      outline: none;
    }
  }

  .i-autocomplete .autocomplete[data-position='below'] .autocomplete-input[aria-expanded='true'] {
    border-radius: rs(math.div(58px, 2));
  }

  .i-autocomplete .autocomplete[data-position='above'] .autocomplete-input[aria-expanded='true'] {
    border-radius: rs(math.div(58px, 2));
  }

  .i-autocomplete .autocomplete-result-list {
    background: #f5f5f5;
    border: 0;
  }

  .i-autocomplete .autocomplete[data-position='below'] .autocomplete-result-list,
  .i-autocomplete .autocomplete[data-position='above'] .autocomplete-result-list {
    border-radius: rs(10px);
    padding-bottom: 0;
    transform: translateY(-10px);
    top: auto !important;
    bottom: 100% !important;
  }

  // .i-autocomplete .autocomplete[data-position='above'] .autocomplete-result-list {
  //   border-radius: rs(10px);
  //   padding-top: 0;
  //   transform: translateY(-10px);
  // }

  .i-autocomplete .autocomplete-result {
    padding: rs(10px) rs(24px);
    font-size: rf(18px);
    color: #4a4a4a;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;

    span {
      color: #ea6d78;
      font-weight: bold;
    }

    &:not(:first-child) {
      border-top: 1px solid darken(#f5f5f5, 3%);
    }
  }
</style>
